Subject: Re: [PATCH net] net: skbuff: propagate shared-frag marker through pskb_copy()

From: Hyunwoo Kim <[email-masked]>
Date: Thu, 14 May 2026 03:30:51 +0900

On Thu, May 14, 2026 at 02:16:31AM +0900, Hyunwoo Kim wrote:
> On Wed, May 13, 2026 at 06:21:45PM +0200, Ben Hutchings wrote:
> > On Wed, 2026-05-13 at 20:25 +0900, Hyunwoo Kim wrote:
> > > __pskb_copy_fclone() shallow-copies the source's frag descriptors and
> > > bumps each page's refcount via skb_frag_ref(), then defers the rest
> > > of the shinfo metadata to skb_copy_header().  That helper only carries
> > > over gso_{size,segs,type} and never touches skb_shinfo()->flags, so
> > > the destination skb keeps a reference to the same externally-owned or
> > > page-cache-backed pages while reporting skb_has_shared_frag() as
> > > false.
> > >
> > > The mismatch is harmful in any in-place writer that uses
> > > skb_has_shared_frag() to decide whether shared pages must be detoured
> > > through skb_cow_data().  ESP input is one such writer (esp4.c,
> > > esp6.c), and a single nft 'dup to <local>' rule -- or any other
> > > nf_dup_ipv4() / xt_TEE caller -- is enough to land a pskb_copy()'d
> > > skb in esp_input() with the marker stripped, letting an unprivileged
> > > user write into the page cache of a root-owned read-only file via
> > > authencesn-ESN stray writes.
> > > 
> > > Set SKBFL_SHARED_FRAG on the destination whenever frag descriptors
> > > were actually moved from the source.  skb_copy() and skb_copy_expand()
> > > share skb_copy_header() too but linearize all paged data into freshly
> > > allocated head storage and emerge with nr_frags == 0, so
> > > skb_has_shared_frag() returns false on its own; they need no change.
> > 
> > What about skb_shift()?  It seems like that should also propagate this
> > flag.  But I could be missing some reason why it's not necessary.
> 
> Yes, since skb_shift() is also a function that moves frag descriptors, 
> I think SHARED_FRAG should be propagated as well. The actual trigger 
> conditions are tricky (not deterministic) due to TCP write-queue skb 
> merging, but I believe the fix is the right thing to do. 
> 
> I'm planning to submit a v2 patch. What do you think?

And skb_gro_receive() also appears to need work. Further testing is 
in progress...

> Best regards,
> Hyunwoo Kim